VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public lHwnd As Long
Private oPics As Collection

Private lngMenu As Long
Private lngSubMenu As Long
Private lngMenuItemID As Long
Private lngRet As Long

Private Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Private Declare Function SetMenuItemBitmaps Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, ByVal hBitmapUnchecked As Long, ByVal hBitmapChecked As Long) As Long
Private Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Private Declare Function GetMenuState Lib "user32" (ByVal hMenu As Long, ByVal wID As Long, ByVal wFlags As Long) As Long
Private Declare Function CheckMenuRadioItem Lib "user32" (ByVal hMenu As Long, ByVal un1 As Long, ByVal un2 As Long, ByVal un3 As Long, ByVal un4 As Long) As Long
Private Const MF_BYPOSITION = &H400&
Private Const MF_CHECKED = &H8&

'in your form, just put this code block in the form_load method
'    Dim oImages As MenuImage
'    Set oImages = New MenuImage
'    oImages.AddIcon pic1.Picture, 1, 1
'    oImages.AddIcon pic2.Picture, 1, 3
'    oImages.AddIcon pic3.Picture, 2, 1
'    oImages.AddIcon pic4.Picture, 2, 4
'    oImages.CreateMenu Me.hwnd
'    Set oImages = Nothing



Public Function AddIcon(oImage As StdPicture, iMenu As Integer, iSubMenu As Integer) As Boolean
    On Error GoTo ErrorHandle
    
    AddIcon = True
    oPics.Add oImage, "KEY" & iMenu & iSubMenu
    Exit Function
    
ErrorHandle:
    MsgBox Err.Description, vbCritical, "Easy Menu Images Error!"
    AddIcon = False
    
End Function

Public Function CreateMenu(lFormHandle As Long) As Boolean
    Dim x As Long
    Dim y As Long
    On Error GoTo ErrorHandle
    CreateMenu = True
    
    lngMenu = GetMenu(lFormHandle)   '0 = error
    For x = 0 To GetMenuItemCount(lngMenu) - 1
        lngSubMenu = GetSubMenu(lngMenu, x) '0 = error
        For y = 0 To GetMenuItemCount(lngSubMenu) - 1
            lngMenuItemID = GetMenuItemID(lngSubMenu, y) '-1 = error
            On Error Resume Next
            lngRet = SetMenuItemBitmaps(lngMenu, lngMenuItemID, 0, oPics.Item("KEY" & x + 1 & y + 1), oPics.Item("KEY" & x + 1 & y + 1))
            On Error GoTo 0
        Next
    Next
    Exit Function
    
ErrorHandle:
    MsgBox Err.Description, vbCritical, "Easy Menu Images Error!"
    CreateMenu = False
    
End Function

Public Function SetMenuRadio(lpos As Long)
    Dim lRet As Long
    lngMenu = GetMenu(lHwnd)   '0 = error
    lngSubMenu = GetSubMenu(lngMenu, 1) '0 = error
    lRet = CheckMenuRadioItem(lngSubMenu, 0, 3, lpos - 1, MF_BYPOSITION)
End Function

Public Function CheckRadioMenu(lMenu As Long, lSubMenu As Long) As Boolean
    Dim lRet As Long
    lngMenu = GetMenu(lHwnd)
    lngSubMenu = GetSubMenu(lngMenu, lMenu - 1)
    lRet = GetMenuState(lngSubMenu, lSubMenu - 1, MF_BYPOSITION)
    If lRet = (MF_CHECKED + 512) Then
        CheckRadioMenu = True
    Else
        CheckRadioMenu = False
    End If
End Function

Public Function GetRadioMenuFromGroup(lMenu) As Long
    Dim lRet As Long
    Dim x As Long
    lngMenu = GetMenu(lHwnd)
    lngSubMenu = GetSubMenu(lngMenu, lMenu - 1)
    For x = 0 To GetMenuItemCount(lngSubMenu) - 1
        lRet = GetMenuState(lngSubMenu, x, MF_BYPOSITION)
        If lRet = (MF_CHECKED + 512) Then
            GetRadioMenuFromGroup = x + 1
            Exit For
        Else
            GetRadioMenuFromGroup = 0
        End If
    Next
End Function

Private Sub Class_Initialize()
    Set oPics = New Collection
End Sub

Private Sub Class_Terminate()
    Set oPics = Nothing
End Sub




